SystemOrganization addCategory: #'PLP-TP3'!

TestCase subclass: #TransformadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'FelipeBonet 11/9/2013 21:24'!
testTransAleatorio

	| trans2 trans3 trans10 |
	trans10 := self transformador10 .
	trans2 := self transformador2 .
	trans3 := self transformador3 .
	self assert: ( (trans10 transformar: 'paboloco') = (trans2 transformar: 'paboloco') or: (trans10 transformar: 'paboloco') = (trans3 transformar: 'paboloco')).
	self assert: ( (trans10 transformar: 'monoloco') = (trans2 transformar: 'monoloco') or: (trans10 transformar: 'monoloco') = (trans3 transformar: 'monoloco')).
	self assert: ( (trans10 transformar: 'elosodeaimao') = (trans2 transformar: 'elosodeaimao') or: (trans10 transformar: 'elosodeaimao') = (trans3 transformar: 'elosodeaimao')).
	self assert: ( (trans10 transformar: 'patoloco') = (trans2 transformar: 'patoloco') or: (trans10 transformar: 'patoloco') = (trans3 transformar: 'patoloco')).
	self assert: ( (trans10 transformar: 'abecedario') = (trans2 transformar: 'abecedario') or: (trans10 transformar: 'abecedario') = (trans3 transformar: 'abecedario')).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:39'!
testTransBloque

	| trans5 unBloque unaColeccionOrdenada |
	trans5 := self transformador5 .
	unaColeccionOrdenada := OrderedCollection new.
	unBloque := [ unaColeccionOrdenada add: 0 ].
	
	(trans5 transformar: unBloque) value.
	self assert: ( unaColeccionOrdenada size = 3 ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 11/5/2013 00:01'!
testTransCaracter

	| trans2 trans3 |
	trans2 := self transformador2 .
	trans3 := self transformador3 .
	
	self assert: ( (trans2 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans2 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans3 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans3 transformar: 'patoloco') = 'patoloco' ).
! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ManuelGimenez 11/5/2013 00:02'!
testTransCondicion

	| trans8 trans9 
	unStringImpar otroStringImpar unStringPar otroStringPar 
	unBloquePar unBloqueImpar unaColeccionOrdenada unNuevoBloque |
	
	trans8 := self transformador8 .
	trans9 := self transformador9 .
	
	unStringImpar := 'bab'.
	unStringPar := 'aa'.
	otroStringImpar := 'aaa'.
	otroStringPar := 'bb'.
	
	self assert: ( (trans8 transformar: unStringPar) = 'bb' ).
	self assert: ( (trans8 transformar: unStringImpar) = 'aaa' ).
	self assert: ( (trans8 transformar: otroStringPar) = otroStringPar ).
	self assert: ( (trans8 transformar: otroStringImpar ) = otroStringImpar ).
	
	unaColeccionOrdenada := OrderedCollection new.
	unBloquePar := [ unaColeccionOrdenada add:0. ^4 ].
	unBloqueImpar := [ unaColeccionOrdenada add:0. ^3 ].
	
	unNuevoBloque := trans9 transformar: unBloquePar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 3).
	
	unNuevoBloque := trans9 transformar: unBloqueImpar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 1).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:04'!
testTransIdentidad

| unTransformadorIdentidad |
unTransformadorIdentidad := self transformador1 .
self assert: ( unTransformadorIdentidad transformar: self == self ).! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ManuelGimenez 11/5/2013 00:01'!
testTransSecuencial

	| trans6 trans7 |
	trans6 := self transformador6 .
	trans7 := self transformador7 .
	
	self assert: ( (trans6 transformar: 'patoloco') = 'patoloco' ).
	self assert: ( (trans6 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans6 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans7 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans7 transformar: 'monoloco') = 'monoloco' ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:22'!
testTransSubstring

	| trans4 |
	trans4 := self transformador4 .
	
	self assert: ( (trans4 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans4 transformar: 'buu') = 'md' ).
	self assert: ( (trans4 transformar: 'monobuuloco') = 'monomdloco' ).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 16:25'!
transformador1
	"Debe retornar el transformador especificado en el enunciado"
	^TransIdentidad  new.! !

!TransformadorTest methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 21:23'!
transformador10
	"reemplaza el substring buu por md"
	^TransSecuencial nuevoCon: self transformador2 Y: self transformador3.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 17:05'!
transformador2
	"Reemplaza a por b"
	^TransCaracter nuevoCon: 'a' Y: 'b'. ! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 17:05'!
transformador3
	"Reemplaza b por a"
	^TransCaracter nuevoCon: 'b' Y: 'a'.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 17:15'!
transformador4
	"reemplaza el substring buu por md"
	^TransSubstring nuevoCon: 'buu' Y: 'md'.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 17:35'!
transformador5
	"crea un TransBloque con n = 3"
	^TransBloque nuevoCon: 3.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 19:41'!
transformador6
	"reemplaza el substring buu por md"
	^TransSecuencial nuevoCon: self transformador2 Y: self transformador3.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 19:42'!
transformador7
		"reemplaza el substring buu por md"
	^TransSecuencial nuevoCon: self transformador6 Y: self transformador2.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 20:26'!
transformador8
	"Debe retornar el transformador especificado en el enunciado"
	^(TransCondicion nuevoCon: self transformador2 Y: self transformador3) condicion: [:aString | aString size even ].! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'FelipeBonet 11/9/2013 20:57'!
transformador9
	"Debe retornar el transformador especificado en el enunciado"
	^(TransCondicion nuevoCon: self transformador5 Y: self transformador1) condicion: [:aBlock | aBlock value even ].! !

Object subclass: #Arreglador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Arreglador class methodsFor: 'as yet unclassified' stamp: 'ManuelGimenez 10/29/2013 23:03'!
arreglar
	"Debe modificar la implementacion para reflejar complacer el ultimo capricho del arquitecto"
	self notYetImplemented .! !

Object subclass: #Transformador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

Transformador subclass: #TransBloque
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransBloque class methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:32'!
nuevoCon: valorN 
	 "inicia TransBloque definiendo el numero de iteraciones del bloque"

	^self new iniciarCon: valorN. ! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:33'!
iniciarCon: valorN
	
	n := valorN.
	! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 19:35'!
transformar: unBloque 

	  | count |
       
       count := 0.
       
       [ count  < n ] whileTrue: [unBloque value. count := count + 1]! !

Transformador subclass: #TransCaracter
	instanceVariableNames: 'oldChar newChar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransCaracter class methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:00'!
nuevoCon: unViejoChar Y: unNuevoChar 
	 "inicia TransCaracter definiendo los caracteres a reemplazar y ser reemplazado"

	^self new iniciarCon: unViejoChar Y: unNuevoChar . ! !

!TransCaracter methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:02'!
iniciarCon: unViejoChar Y: unNuevoChar
	
	oldChar := unViejoChar.
	newChar := unNuevoChar.! !

!TransCaracter methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:03'!
transformar: unString 
	^ unString copyReplaceAll: oldChar with: newChar. ! !

Transformador subclass: #TransCompuesto
	instanceVariableNames: 'trans1 trans2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

TransCompuesto subclass: #TransAleatorio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransAleatorio methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 21:23'!
transformar: unObjeto 
	| valRand |
	valRand := Random new.
	valRand  nextInt: 2.
	[ (valRand nextInt: 2) = 1 ] ifTrue: (trans1 transformar: unObjeto) ifFalse: (trans2 transformar: unObjeto).! !

!TransCompuesto class methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 20:13'!
nuevoCon: unaTrans1 Y: unaTrans2  
	 "inicia TransCompuesto con sus transformaciones"

	^self new iniciarCon: unaTrans1 Y: unaTrans2.! !

!TransCompuesto methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 20:15'!
iniciarCon: unaTrans1 Y: unaTrans2
	
	trans1 := unaTrans1 .
	trans2 := unaTrans2.! !

TransCompuesto subclass: #TransCondicion
	instanceVariableNames: 'cond'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 20:21'!
condicion: aCond

	cond := aCond.! !

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 21:00'!
transformar: unObjeto 

	^ (cond value: unObjeto) ifTrue: (trans1 transformar: unObjeto) ifFalse: (trans2 transformar: unObjeto)! !

TransCompuesto subclass: #TransSecuencial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransSecuencial methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 19:44'!
transformar: unObjeto 

	^trans2 transformar: (trans1 transformar: unObjeto) ! !

Transformador subclass: #TransIdentidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransIdentidad methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:46'!
transformar: unObjeto
	^unObjeto.! !

Transformador subclass: #TransSubstring
	instanceVariableNames: 'oldSubstring newSubstring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransSubstring class methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:13'!
nuevoCon: unViejoSubstring Y: unNuevoSubstring 
	 "inicia TransCaracter definiendo los caracteres a reemplazar y ser reemplazado"

	^self new iniciarCon: unViejoSubstring Y: unNuevoSubstring . ! !

!TransSubstring methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:09'!
iniciarCon: unViejoSubstring Y: unNuevoSubstring
	
	oldSubstring := unViejoSubstring.
	newSubstring := unNuevoSubstring.! !

!TransSubstring methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 17:17'!
transformar: unString 
	^ unString copyReplaceAll: oldSubstring with: newSubstring. ! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'FelipeBonet 11/9/2013 16:21'!
transformar: unObjeto
	^self subclassResponsibility .! !
